# -*- coding: utf-8 -*-
"""
Created on Sun Mar 26 23:40:01 2023

@author: clari

Last updated on March, 27th 2023 by Matheus BELISARIO DE ABREU, Ziyad BENKHADAJ,
Alice RENAUX, Henrique SILVESTRE and Clarice VELLOSO.

"""

# Created by: PyQt5 UI code generator 5.9.2

from PyQt5 import QtCore, QtWidgets
from serial import Serial
import serial.tools.list_ports

class Ui_MainWindow(object):

    def __init__(self):
        
        # To open the serial communication at a specific baudrate
        self.Ui_MainWindow_serNuc = Serial(
            serial.tools.list_ports.comports()[0].name, 115200
        )

    def setupUi(self, MainWindow):
        
        # Creating the main window
        MainWindow.setObjectName("MainWindow")
        MainWindow.resize(401, 600)
        self.centralwidget = QtWidgets.QWidget(MainWindow)
        self.centralwidget.setObjectName("centralwidget")
        
        # Send Button
        self.pushButton = QtWidgets.QPushButton(self.centralwidget)
        self.pushButton.setGeometry(QtCore.QRect(40, 500, 93, 28))
        self.pushButton.setObjectName("pushButton")
        
        # Layout configuration
        self.widget = QtWidgets.QWidget(self.centralwidget)
        self.widget.setGeometry(QtCore.QRect(40, 70, 324, 421))
        self.widget.setObjectName("widget")
        self.gridLayout_4 = QtWidgets.QGridLayout(self.widget)
        self.gridLayout_4.setContentsMargins(0, 0, 0, 0)
        self.gridLayout_4.setObjectName("gridLayout_4")
        self.gridLayout_2 = QtWidgets.QGridLayout()
        self.gridLayout_2.setObjectName("gridLayout_2")
        self.label_4 = QtWidgets.QLabel(self.widget)
        self.label_4.setObjectName("label_4")
        self.gridLayout_2.addWidget(self.label_4, 1, 1, 1, 1)
        
        # Defining the GREEN LCD screen
        self.GREENLCD = QtWidgets.QLCDNumber(self.widget)
        self.GREENLCD.setProperty("value", 1.0)
        self.GREENLCD.setObjectName("GREENLCD")
        self.gridLayout_2.addWidget(self.GREENLCD, 2, 0, 1, 1)
        
        self.label_2 = QtWidgets.QLabel(self.widget)
        self.label_2.setObjectName("label_2")
        self.gridLayout_2.addWidget(self.label_2, 2, 1, 1, 1)
        
        # Defining the BLUE LCD screen
        self.BLUELCD = QtWidgets.QLCDNumber(self.widget)
        self.BLUELCD.setProperty("value", 1.0)
        self.BLUELCD.setObjectName("BLUELCD")
        self.gridLayout_2.addWidget(self.BLUELCD, 3, 0, 1, 1)
        
        # Defining the check box KEY1
        self.check_KEY1 = QtWidgets.QCheckBox(self.widget)
        self.check_KEY1.setObjectName("check_KEY1")
        self.gridLayout_2.addWidget(self.check_KEY1, 0, 0, 1, 2)
        
        
        self.label_6 = QtWidgets.QLabel(self.widget)
        self.label_6.setObjectName("label_6")
        self.gridLayout_2.addWidget(self.label_6, 3, 1, 1, 1)
        
        # Defining the RED LCD screen
        self.REDLCD = QtWidgets.QLCDNumber(self.widget)
        self.REDLCD.setProperty("value", 1.0)
        self.REDLCD.setObjectName("REDLCD")
        self.gridLayout_2.addWidget(self.REDLCD, 1, 0, 1, 1)
        
        
        self.gridLayout_4.addLayout(self.gridLayout_2, 1, 0, 1, 1)
        self.gridLayout_3 = QtWidgets.QGridLayout()
        self.gridLayout_3.setObjectName("gridLayout_3")
        
        # Defining the second RED LCD screen
        self.REDLCD_2 = QtWidgets.QLCDNumber(self.widget)
        self.REDLCD_2.setProperty("value", 1.0)
        self.REDLCD_2.setObjectName("REDLCD_2")
        self.gridLayout_3.addWidget(self.REDLCD_2, 1, 0, 1, 1)
        
        # Defining the second GREEN LCD screen
        self.GREENLCD_2 = QtWidgets.QLCDNumber(self.widget)
        self.GREENLCD_2.setProperty("value", 1.0)
        self.GREENLCD_2.setObjectName("GREENLCD_2")
        self.gridLayout_3.addWidget(self.GREENLCD_2, 2, 0, 1, 1)
        
        
        self.label_8 = QtWidgets.QLabel(self.widget)
        self.label_8.setObjectName("label_8")
        self.gridLayout_3.addWidget(self.label_8, 2, 1, 1, 1)
        
        # Defining the check box KEY2
        self.check_KEY1_2 = QtWidgets.QCheckBox(self.widget)
        self.check_KEY1_2.setObjectName("check_KEY1_2")
        self.gridLayout_3.addWidget(self.check_KEY1_2, 0, 0, 1, 2)
        
        
        self.label_9 = QtWidgets.QLabel(self.widget)
        self.label_9.setObjectName("label_9")
        self.gridLayout_3.addWidget(self.label_9, 3, 1, 1, 1)
        self.label_7 = QtWidgets.QLabel(self.widget)
        self.label_7.setObjectName("label_7")
        self.gridLayout_3.addWidget(self.label_7, 1, 1, 1, 1)
        
        
        # Defining the second BLUE LCD screen
        self.BLUELCD_2 = QtWidgets.QLCDNumber(self.widget)
        self.BLUELCD_2.setProperty("value", 1.0)
        self.BLUELCD_2.setObjectName("BLUELCD_2")
        self.gridLayout_3.addWidget(self.BLUELCD_2, 3, 0, 1, 1)
        
        
        self.gridLayout_4.addLayout(self.gridLayout_3, 1, 1, 1, 1)
        self.gridLayout = QtWidgets.QGridLayout()
        self.gridLayout.setObjectName("gridLayout")
        self.label = QtWidgets.QLabel(self.widget)
        self.label.setObjectName("label")
        self.gridLayout.addWidget(self.label, 0, 0, 1, 1)
        
        # Defining the GREEN slider
        self.R_2 = QtWidgets.QSlider(self.widget)
        self.R_2.setMinimum(1)
        self.R_2.setMaximum(255)
        self.R_2.setOrientation(QtCore.Qt.Vertical)
        self.R_2.setObjectName("R_2")
        self.gridLayout.addWidget(self.R_2, 2, 1, 1, 1)
        
        
        self.label_3 = QtWidgets.QLabel(self.widget)
        self.label_3.setObjectName("label_3")
        self.gridLayout.addWidget(self.label_3, 0, 2, 1, 1)
        
        # Defining the BLUE spinbox
        self.spinBox_3 = QtWidgets.QSpinBox(self.widget)
        self.spinBox_3.setMinimum(1)
        self.spinBox_3.setMaximum(255)
        self.spinBox_3.setObjectName("spinBox_3")
        self.gridLayout.addWidget(self.spinBox_3, 1, 2, 1, 1)
        
        # Defining the BLUE slider
        self.R_3 = QtWidgets.QSlider(self.widget)
        self.R_3.setMinimum(1)
        self.R_3.setMaximum(255)
        self.R_3.setOrientation(QtCore.Qt.Vertical)
        self.R_3.setObjectName("R_3")
        self.gridLayout.addWidget(self.R_3, 2, 2, 1, 1)
        
        # Defining the BLUE spinbox
        self.spinBox_2 = QtWidgets.QSpinBox(self.widget)
        self.spinBox_2.setMinimum(1)
        self.spinBox_2.setMaximum(255)
        self.spinBox_2.setObjectName("spinBox_2")
        self.gridLayout.addWidget(self.spinBox_2, 1, 1, 1, 1)
        
        # Defining the RED slider
        self.R = QtWidgets.QSlider(self.widget)
        self.R.setMinimum(1)
        self.R.setMaximum(255)
        self.R.setOrientation(QtCore.Qt.Vertical)
        self.R.setObjectName("R")
        self.gridLayout.addWidget(self.R, 2, 0, 1, 1)
        
        # Defining the RED spinbox
        self.spinBox = QtWidgets.QSpinBox(self.widget)
        self.spinBox.setMinimum(1)
        self.spinBox.setMaximum(255)
        self.spinBox.setObjectName("spinBox")
        self.gridLayout.addWidget(self.spinBox, 1, 0, 1, 1)
        
        
        self.label_5 = QtWidgets.QLabel(self.widget)
        self.label_5.setObjectName("label_5")
        self.gridLayout.addWidget(self.label_5, 0, 1, 1, 1)
        spacerItem = QtWidgets.QSpacerItem(20, 40,
            QtWidgets.QSizePolicy.Minimum, QtWidgets.QSizePolicy.Fixed)
        self.gridLayout.addItem(spacerItem, 3, 0, 1, 3)
        self.gridLayout_4.addLayout(self.gridLayout, 0, 0, 1, 2)
        MainWindow.setCentralWidget(self.centralwidget)
        self.menubar = QtWidgets.QMenuBar(MainWindow)
        self.menubar.setGeometry(QtCore.QRect(0, 0, 401, 26))
        self.menubar.setObjectName("menubar")
        MainWindow.setMenuBar(self.menubar)
        self.statusbar = QtWidgets.QStatusBar(MainWindow)
        self.statusbar.setObjectName("statusbar")
        MainWindow.setStatusBar(self.statusbar)
        
        # Connecting the Sliders and the Spin Boxes to display the same value
        self.retranslateUi(MainWindow)
        self.R.valueChanged['int'].connect(self.spinBox.setValue)
        self.spinBox.valueChanged['int'].connect(self.R.setValue)
        self.R_2.valueChanged['int'].connect(self.spinBox_2.setValue)
        self.spinBox_2.valueChanged['int'].connect(self.R_2.setValue)
        self.spinBox_3.valueChanged['int'].connect(self.R_3.setValue)
        self.R_3.valueChanged['int'].connect(self.spinBox_3.setValue)
        
        # Connecting the check boxes to functions below
        self.check_KEY1.stateChanged.connect(lambda:self.btnstate(self.check_KEY1))
        self.check_KEY1_2.stateChanged.connect(lambda:self.btnstate2(self.check_KEY1_2))
        
        # Connecting the send button to function that sends data in Serial
        self.pushButton.clicked.connect(lambda:self.sendRGB(self.pushButton))
        QtCore.QMetaObject.connectSlotsByName(MainWindow)
        
    
    def btnstate(self,check_KEY1):
        '''
        This function connects the sliders to the LCD display only if the
        check box is checked.
        If the boxe is unchecked, it disconnects the LCD from the slider.
        ----------
        check_KEY1 : Check box
            Can be checked or not by the user on the interface.

        Returns
        -------
        None.

        '''
        if check_KEY1.isChecked() == True:
            self.R.valueChanged['int'].connect(self.REDLCD.display)
            self.R_2.valueChanged['int'].connect(self.GREENLCD.display)
            self.R_3.valueChanged['int'].connect(self.BLUELCD.display)
        else:
            self.R.valueChanged['int'].disconnect(self.REDLCD.display)
            self.R_2.valueChanged['int'].disconnect(self.GREENLCD.display)
            self.R_3.valueChanged['int'].disconnect(self.BLUELCD.display)

    def btnstate2(self,check_KEY1_2):
        '''
        This function connects the sliders to the LCD display only if the
        check box is checked.
        If the boxe is unchecked, it disconnects the LCD from the slider.

        Parameters
        ----------
        check_KEY1 : Check box
            Can be checked or not by the user on the interface.

        Returns
        -------
        None.

        '''
        if check_KEY1_2.isChecked() == True:
            self.R.valueChanged['int'].connect(self.REDLCD_2.display)
            self.R_2.valueChanged['int'].connect(self.GREENLCD_2.display)
            self.R_3.valueChanged['int'].connect(self.BLUELCD_2.display)
        else:
            self.R.valueChanged['int'].disconnect(self.REDLCD_2.display)
            self.R_2.valueChanged['int'].disconnect(self.GREENLCD_2.display)
            self.R_3.valueChanged['int'].disconnect(self.BLUELCD_2.display)
    

    def sendRGB(self, Pushbutton):
        '''
        This function sends the information to the microcontroller with
        PySerial when the Send button is pressed.

        Parameters
        ----------
            None.

        Returns
        -------
            None.
        '''

        if self.check_KEY1.isChecked() == True:
            key = '1'
            # To convert the RGB values into HEX '&RRGGBB' format
            # Integer values
            REDvalue = self.REDLCD.intValue()
            GREENvalue = self.GREENLCD.intValue()
            BLUEvalue = self.BLUELCD.intValue()

        elif self.check_KEY1_2.isChecked() == True:
            key = '2'
            # To convert the RGB values into HEX '&RRGGBB' format
            # Integer values
            REDvalue = self.REDLCD_2.intValue()
            GREENvalue = self.GREENLCD_2.intValue()
            BLUEvalue = self.BLUELCD_2.intValue()

        # Hexadecimal values
        REDhex = "{:02x}".format(REDvalue)
        GREENhex = "{:02x}".format(GREENvalue)
        BLUEhex = "{:02x}".format(BLUEvalue)        
        
        color_code = '&' + key + REDhex + GREENhex + BLUEhex

        # Sending the information '&RRGGBB'        
        self.Ui_MainWindow_serNuc.write(bytes(color_code, 'ascii'))
        
    
    def retranslateUi(self, MainWindow):
        '''
        This function...

        Parameters
        ----------
            MainWindow : 
        
        Returns
        -------
            None.
        '''
        _translate = QtCore.QCoreApplication.translate
        MainWindow.setWindowTitle(_translate("MainWindow", "MainWindow"))
        
        # Making the labels of each widget.
        self.pushButton.setText(_translate("MainWindow", "Send"))
        self.label_4.setText(_translate("MainWindow", "RED"))
        self.label_2.setText(_translate("MainWindow", "GREEN"))
        self.check_KEY1.setText(_translate("MainWindow", "Key 1"))
        self.label_6.setText(_translate("MainWindow", "BLUE"))
        self.label_8.setText(_translate("MainWindow", "GREEN"))
        self.check_KEY1_2.setText(_translate("MainWindow", "Key 2"))
        self.label_9.setText(_translate("MainWindow", "BLUE"))
        self.label_7.setText(_translate("MainWindow", "RED"))
        self.label.setText(_translate("MainWindow", "RED"))
        self.label_3.setText(_translate("MainWindow", "BLUE"))
        self.label_5.setText(_translate("MainWindow", "GREEN"))