# -*- coding: utf-8 -*-
"""

@author: clarice.velloso

    Based on example:
    First application with pyQT5 / Spyder 
        Interface designed with QT Designer - mainWindow.ui
        This example requires the mainWindow.ui file (created on QTDesigner)
    
    Author : Julien VILLEMEJANE
    Laboratoire d Enseignement Experimental - Institut d Optique Graduate School
    Created on Sat Jan 14 20:34:05 2023
    
    @author: julien.villemejane
    
    Last updated on March, 27th 2023 by Matheus BELISARIO DE ABREU, Ziyad BENKHADAJ,
    Alice RENAUX, Henrique SILVESTRE and Clarice VELLOSO.
"""

import sys

from PyQt5.QtWidgets import (
    QApplication, QMainWindow
)

# Importing the Ui that has the interface information
from RGB2v3 import Ui_MainWindow

# Importing Pyserial to emit the Serial signals
from serial import Serial
import serial.tools.list_ports


class Window(QMainWindow):

    
    def __init__(self, parent=None):
        """
        Initializes the main window of the application

        Parameters
        ----------
        parent : argv from sys
            Default is None.

        Returns
        -------
        None.

        """
        super().__init__(parent)
        self.ui = Ui_MainWindow()
        self.ui.setupUi(self)
        
        

if __name__ == "__main__":    
    
    app = QApplication(sys.argv)
    win = Window()
    win.show()
    sys.exit(app.exec())